///////////////////////////////////////////////////////////////////////////////
// Name:		wxMrtEdit.cpp
// Purpose:     Mrt Style Edit
// Author:      emarti, Murat zdemir  e-mail: dtemarti<add>gmail<dot>com
// Created:     27.04.2006
// Copyright:   (c) emarti
// Licence:     GPL
///////////////////////////////////////////////////////////////////////////////

#ifndef WX_PRECOMP 
    #include "wx/wx.h" 
#endif 

#include "wxMrtEdit.h"

// wxMrtEdit Event Table
BEGIN_EVENT_TABLE(wxMrtEdit, wxControl) 
    EVT_PAINT(wxMrtEdit::OnPaint)
	EVT_ENTER_WINDOW(wxMrtEdit::MouseEnter)
	EVT_LEAVE_WINDOW(wxMrtEdit::MouseLeave)
	EVT_LEFT_DOWN(wxMrtEdit::LeftDown)
END_EVENT_TABLE()

// wxMetin Event Table
BEGIN_EVENT_TABLE(wxMetin, wxTextCtrl) 
	EVT_LEAVE_WINDOW( wxMetin::Out)
END_EVENT_TABLE()

wxMetin::wxMetin(wxMrtEdit *MrtEdit,wxWindowID id, wxString value,int x, int y, int w, int h, long style)
	: wxTextCtrl(MrtEdit->GetParent(), id, value, wxPoint(x,y), wxSize(w-2,h-2), wxNO_BORDER | style )
{
	Mrt = MrtEdit;
}

wxMetin::~wxMetin()
{

}

wxMrtEdit::wxMrtEdit(wxWindow *parent, wxWindowID id, wxString value, int x, int y, int width, int height, int kind, long style, wxColour frameColour, wxColour insideframeColour, wxColour backgroundColour) 
                  : wxControl(parent, id,  wxPoint(x, y), wxSize(width, height), wxBORDER_NONE) 
{ 	
	w = width;
	h = height;
	k = kind;
    Text = new wxMetin(this, wxID_ANY, value,1+x,1+y,w,h, wxNO_BORDER | style);
	Text->SetBackgroundColour(backgroundColour);
	SetBackgroundColour(backgroundColour);
	m_frameColour = frameColour;
	m_insideframeColour = insideframeColour;

	inside = false;
	wxControl::Enable(true);
	Show(true);
	
} 

wxMrtEdit::~wxMrtEdit() 
{ 
	delete Text;
} 

void wxMrtEdit::OnPaint(wxPaintEvent& WXUNUSED(event)) 
{    
	wxPaintDC dc(this);
	wxPen pen(m_frameColour,1,wxSOLID);
	if (inside) pen.SetColour(m_insideframeColour);
    dc.SetPen(pen);
	switch(k){
	case K_RECTANGLE:	
		{	
			dc.DrawRectangle(0,0,w,h); 
			break;
		}
	case K_LINE:		
		{
			dc.DrawLine(0,h-1,w,h-1); 
			break;
		}
	case K_DOUBLELINE:	
		{
			dc.DrawLine(0,0,w,0); 
			dc.DrawLine(0,h-1,w,h-1); 
			break;
		}
	}
}

void Yenile(wxMrtEdit* m)
{
	m->Text->Refresh();
	m->Refresh();
}

void wxMrtEdit::MouseEnter(wxMouseEvent& event)
{
	inside = true;
	Yenile(this);
	event.Skip();
}

void wxMrtEdit::MouseLeave(wxMouseEvent& event)
{
	inside = false;
	Yenile(this);
	event.Skip();
}

void wxMrtEdit::LeftDown(wxMouseEvent& event)
{
	Yenile(this);
	wxControl::Enable(false);
	event.Skip();
}

void wxMetin::Out(wxMouseEvent& event)
{
	Yenile(Mrt);
	Mrt->wxControl::Enable(true);
	event.Skip();
}

